require 'dry/inflector'
require 'the_factory/dsl'
require 'the_factory/decoration_helpers'
require 'the_factory/inheritance_helpers'
require 'the_factory/module_builder'
require 'the_factory/composite'
require 'the_factory/registry'
require 'the_factory/dsl'
require 'the_factory/version'

module TheFactory
  class Error < StandardError; end

  module ClassMethods
    def composed_of(*components_names)
      components_names.each do |components_name|
        include TheFactory::Composite[components_name]
      end
    end
  end

  def self.included(receiver)
    receiver.extend ClassMethods
  end

  def self.inflector
    @inflector ||= Dry::Inflector.new
  end

  def self.registered_modules
    Composite.registered_modules
  end
end
